local M = {}
local onetime = 1

local b_one_time1 = 1
local b_one_time2 = 1
local b_one_time3 = 1
local b_one_time4 = 1

local fire_efect1 = 1
local fire_efect2 = 1
local fire_efect3 = 1
local fire_efect4 = 1

local pr_1_1 = nil
local pr_1_2 = nil
local pr_1_3 = nil
local pr_1_4 = nil
local pr_2_1 = nil
local pr_2_2 = nil
local pr_2_3 = nil
local pr_2_4 = nil
local pr_3_1 = nil
local pr_3_2 = nil
local pr_3_3 = nil
local pr_3_4 = nil
local pr_4_1 = nil
local pr_4_2 = nil
local pr_4_3 = nil
local pr_4_4 = nil
local fire1_1 = nil
local fire1_2 = nil
local fire2_1 = nil
local fire2_2 = nil
local fire3_1 = nil
local fire3_2 = nil
local fire4_1 = nil
local fire4_2 = nil

local idleRPM = 40
local thrustLevel = 9400

local function init()
end

local function onInit()
	if v.data.engine then
		if onetime == 1 then
			for k, node in pairs(v.data.nodes) do
					if node.name == "1prop3" then pr_1_1=k
				elseif node.name == "1prop5" then pr_1_2=k
				elseif node.name == "1prop4" then pr_1_3=k
				elseif node.name == "1prop6" then pr_1_4=k
				elseif node.name == "2prop3" then pr_2_1=k
				elseif node.name == "2prop5" then pr_2_2=k
				elseif node.name == "2prop4" then pr_2_3=k
				elseif node.name == "2prop6" then pr_2_4=k
				elseif node.name == "3prop3" then pr_3_1=k
				elseif node.name == "3prop5" then pr_3_2=k
				elseif node.name == "3prop4" then pr_3_3=k
				elseif node.name == "3prop6" then pr_3_4=k
				elseif node.name == "4prop3" then pr_4_1=k
				elseif node.name == "4prop5" then pr_4_2=k
				elseif node.name == "4prop4" then pr_4_3=k
				elseif node.name == "4prop6" then pr_4_4=k
				elseif node.name == "4prop2" then fire1_1=node
				elseif node.name == "4prop1" then fire1_2=node
				elseif node.name == "3prop2" then fire2_1=node
				elseif node.name == "3prop1" then fire2_2=node
				elseif node.name == "2prop2" then fire3_1=node
				elseif node.name == "2prop1" then fire3_2=node
				elseif node.name == "1prop2" then fire4_1=node
				elseif node.name == "1prop1" then fire4_2=node
				end
			end
			onetime = 0
		end
		b_one_time1 = 1
		b_one_time2 = 1
		b_one_time3 = 1
		b_one_time4 = 1
		fire_efect1 = 1
		fire_efect2 = 1
		fire_efect3 = 1
		fire_efect4 = 1
	end
end

local function update(dt)
	if v.data.engine then
		if onetime == 1 then onInit() end
		for i = 0, tableSizeC(v.data.beams) - 1 do
			local beam = v.data.beams[i]
			if beam.breakGroup ~= nil and obj:beamIsBroken(beam.cid) then
				if tostring(beam.breakGroup)=="TITAN_1propinge" or tostring(beam.name)=="EngineDamageL" then electrics.values.engine4_broken = 1 end
				if tostring(beam.breakGroup)=="TITAN_2propinge" or tostring(beam.name)=="EngineDamageL" then electrics.values.engine3_broken = 1 end
				if tostring(beam.breakGroup)=="TITAN_3propinge" or tostring(beam.name)=="EngineDamageR" then electrics.values.engine2_broken = 1 end
				if tostring(beam.breakGroup)=="TITAN_4propinge" or tostring(beam.name)=="EngineDamageR" then electrics.values.engine1_broken = 1 end
			end
		end
		if electrics.values.engine4_turn_on == 1 then
			electrics.values.engine4 = electrics.values.engine4+dt*0.3*math.max(1, electrics.values['cust_throttle']*0.05)
			if electrics.values.engine4 >= 1 then electrics.values.engine4 = 1 electrics.values.engine4_turn_on = 0 end
		end
		if electrics.values.engine4_turn_off == 1 then
			electrics.values.engine4 = electrics.values.engine4-dt*0.2/math.max(1, electrics.values['cust_throttle']*0.02)
			if electrics.values.engine4 <= 0 then electrics.values.engine4 = 0 electrics.values.engine4_turn_off = 0 end
		end
		if electrics.values.engine3_turn_on == 1 then
			electrics.values.engine3 = electrics.values.engine3+dt*0.3*math.max(1, electrics.values['cust_throttle']*0.05)
			if electrics.values.engine3 >= 1 then electrics.values.engine3 = 1 electrics.values.engine3_turn_on = 0 end
		end
		if electrics.values.engine3_turn_off == 1 then
			electrics.values.engine3 = electrics.values.engine3-dt*0.2/math.max(1, electrics.values['cust_throttle']*0.02)
			if electrics.values.engine3 <= 0 then electrics.values.engine3 = 0 electrics.values.engine3_turn_off = 0 end
		end
		if electrics.values.engine2_turn_on == 1 then
			electrics.values.engine2 = electrics.values.engine2+dt*0.3*math.max(1, electrics.values['cust_throttle']*0.05)
			if electrics.values.engine2 >= 1 then electrics.values.engine2 = 1 electrics.values.engine2_turn_on = 0 end
		end
		if electrics.values.engine2_turn_off == 1 then
			electrics.values.engine2 = electrics.values.engine2-dt*0.2/math.max(1, electrics.values['cust_throttle']*0.02)
			if electrics.values.engine2 <= 0 then electrics.values.engine2 = 0 electrics.values.engine2_turn_off = 0 end
		end
		if electrics.values.engine1_turn_on == 1 then
			electrics.values.engine1 = electrics.values.engine1+dt*0.3*math.max(1, electrics.values['cust_throttle']*0.05)
			if electrics.values.engine1 >= 1 then electrics.values.engine1 = 1 electrics.values.engine1_turn_on = 0 end
		end
		if electrics.values.engine1_turn_off == 1 then
			electrics.values.engine1 = electrics.values.engine1-dt*0.2/math.max(1, electrics.values['cust_throttle']*0.02)
			if electrics.values.engine1 <= 0 then electrics.values.engine1 = 0 electrics.values.engine1_turn_off = 0 end
		end
		electrics.values['cust_throttle'] = electrics.values['cust_throttle'] + (electrics.values.chng_throttle * dt * 30)
		electrics.values['cust_throttle'] = clamp(electrics.values['cust_throttle'], 0, 100)
		if electrics.values.chng_throttle ~= 0 then guihooks.message(string.format("Throttle: %d%%", electrics.values['cust_throttle']), 2, "titan_cust_throttle") end
		if electrics.values.engine4_broken == 0 then
			obj:applyForce(pr_1_1, pr_1_2, electrics.values.engine4*(idleRPM+thrustLevel*fire_efect4*electrics.values['cust_throttle']*0.01))
			obj:applyForce(pr_1_2, pr_1_3, electrics.values.engine4*(idleRPM+thrustLevel*fire_efect4*electrics.values['cust_throttle']*0.01))
			obj:applyForce(pr_1_3, pr_1_4, electrics.values.engine4*(idleRPM+thrustLevel*fire_efect4*electrics.values['cust_throttle']*0.01))
			obj:applyForce(pr_1_4, pr_1_1, electrics.values.engine4*(idleRPM+thrustLevel*fire_efect4*electrics.values['cust_throttle']*0.01))
			electrics.values.engine4_sound = (electrics.values.wheelspeed+14)*1.5*electrics.values.engine4
		elseif b_one_time4 == 1 then guihooks.message("Engine 4 broken", 5, "titan_e4") b_one_time4 = 0 electrics.values.engine4_sound = 0
		end
		if electrics.values.engine3_broken == 0 then
			obj:applyForce(pr_2_1, pr_2_2, electrics.values.engine3*(idleRPM+thrustLevel*fire_efect3*electrics.values['cust_throttle']*0.01))
			obj:applyForce(pr_2_2, pr_2_3, electrics.values.engine3*(idleRPM+thrustLevel*fire_efect3*electrics.values['cust_throttle']*0.01))
			obj:applyForce(pr_2_3, pr_2_4, electrics.values.engine3*(idleRPM+thrustLevel*fire_efect3*electrics.values['cust_throttle']*0.01))
			obj:applyForce(pr_2_4, pr_2_1, electrics.values.engine3*(idleRPM+thrustLevel*fire_efect3*electrics.values['cust_throttle']*0.01))
			electrics.values.engine3_sound = (electrics.values.wheelspeed+14)*1.5*electrics.values.engine3
		elseif b_one_time3 == 1 then guihooks.message("Engine 3 broken", 5, "titan_e3") b_one_time3 = 0 electrics.values.engine3_sound = 0
		end
		if electrics.values.engine2_broken == 0 then
			obj:applyForce(pr_3_1, pr_3_2, electrics.values.engine2*(idleRPM+thrustLevel*fire_efect2*electrics.values['cust_throttle']*0.01))
			obj:applyForce(pr_3_2, pr_3_3, electrics.values.engine2*(idleRPM+thrustLevel*fire_efect2*electrics.values['cust_throttle']*0.01))
			obj:applyForce(pr_3_3, pr_3_4, electrics.values.engine2*(idleRPM+thrustLevel*fire_efect2*electrics.values['cust_throttle']*0.01))
			obj:applyForce(pr_3_4, pr_3_1, electrics.values.engine2*(idleRPM+thrustLevel*fire_efect2*electrics.values['cust_throttle']*0.01))
			electrics.values.engine2_sound = (electrics.values.wheelspeed+14)*1.5*electrics.values.engine2
		elseif b_one_time2 == 1 then guihooks.message("Engine 2 broken", 5, "titan_e2") b_one_time2 = 0 electrics.values.engine2_sound = 0
		end
		if electrics.values.engine1_broken == 0 then
			obj:applyForce(pr_4_1, pr_4_2, electrics.values.engine1*(idleRPM+thrustLevel*fire_efect1*electrics.values['cust_throttle']*0.01))
			obj:applyForce(pr_4_2, pr_4_3, electrics.values.engine1*(idleRPM+thrustLevel*fire_efect1*electrics.values['cust_throttle']*0.01))
			obj:applyForce(pr_4_3, pr_4_4, electrics.values.engine1*(idleRPM+thrustLevel*fire_efect1*electrics.values['cust_throttle']*0.01))
			obj:applyForce(pr_4_4, pr_4_1, electrics.values.engine1*(idleRPM+thrustLevel*fire_efect1*electrics.values['cust_throttle']*0.01))
			electrics.values.engine1_sound = (electrics.values.wheelspeed+14)*1.5*electrics.values.engine1
		elseif b_one_time1 == 1 then guihooks.message("Engine 1 broken", 5, "titan_e1") b_one_time1 = 0 electrics.values.engine1_sound = 0
		end
		if electrics.values.engine1onfire == 1 then
			fire_efect1 = math.max(0.5, fire_efect1-dt*0.05)
			obj:addParticleByNodesRelative(fire1_2.cid, fire1_1.cid, -1, 27, 0.5+math.min(50, electrics.values['cust_throttle'])*electrics.values.engine1*0.01, 15+math.min(75, electrics.values['cust_throttle'])*electrics.values.engine1)
			obj:addParticleByNodesRelative(fire1_2.cid, fire1_1.cid, -1, 41, 0.5+electrics.values['cust_throttle']*electrics.values.engine1*0.01, 15+math.min(20, electrics.values['cust_throttle'])*electrics.values.engine1)
		end
		if electrics.values.engine2onfire == 1 then
			fire_efect2 = math.max(0.5, fire_efect2-dt*0.05)
			obj:addParticleByNodesRelative(fire2_2.cid, fire2_1.cid, -1, 27, 0.5+math.min(50, electrics.values['cust_throttle'])*electrics.values.engine2*0.01, 15+math.min(75, electrics.values['cust_throttle'])*electrics.values.engine2)
			obj:addParticleByNodesRelative(fire2_2.cid, fire2_1.cid, -1, 41, 0.5+electrics.values['cust_throttle']*electrics.values.engine2*0.01, 15+math.min(20, electrics.values['cust_throttle'])*electrics.values.engine2)
		end
		if electrics.values.engine3onfire == 1 then
			fire_efect3 = math.max(0.5, fire_efect3-dt*0.05)
			obj:addParticleByNodesRelative(fire3_2.cid, fire3_1.cid, -1, 27, 0.5+math.min(50, electrics.values['cust_throttle'])*electrics.values.engine3*0.01, 15+math.min(75, electrics.values['cust_throttle'])*electrics.values.engine3)
			obj:addParticleByNodesRelative(fire3_2.cid, fire3_1.cid, -1, 41, 0.5+electrics.values['cust_throttle']*electrics.values.engine3*0.01, 15+math.min(20, electrics.values['cust_throttle'])*electrics.values.engine3)
		end
		if electrics.values.engine4onfire == 1 then
			fire_efect4 = math.max(0.5, fire_efect4-dt*0.05)
			obj:addParticleByNodesRelative(fire4_2.cid, fire4_1.cid, -1, 27, 0.5+math.min(50, electrics.values['cust_throttle'])*electrics.values.engine4*0.01, 15+math.min(75, electrics.values['cust_throttle'])*electrics.values.engine4)
			obj:addParticleByNodesRelative(fire4_2.cid, fire4_1.cid, -1, 41, 0.5+electrics.values['cust_throttle']*electrics.values.engine4*0.01, 15+math.min(20, electrics.values['cust_throttle'])*electrics.values.engine4)
		end
	end
	input.event("brake", 1)
	input.event("parkingbrake", 1)
	for i = 0, wheels.wheelCount-1 do
		wheels.wheels[i].brakeTorque = 3000*electrics.values.titan_brake
		wheels.wheels[i].parkingTorque = 10000*electrics.values.titan_p_brk
	end
end

M.init	 = init
M.reset	 = onInit
M.onInit = onInit
M.update = update

return M