
singleton Material(TITAN_vehicle_generic_doorshut)
{
   mapTo = "vehicle_generic_doorshut";
   diffuseColor[0] = "1 1 1 1";
   specular[0] = "1 1 1 1";
   specularPower[0] = "8";
   translucentBlendOp = "LerpAlpha";
   diffuseMap[0] = "vehicles/TITAN/tex4.png";
   diffuseMap[1] = "vehicles/TITAN/tex4.png";
   diffuseMap[2] = "vehicles/TITAN/tex4.png";
   materialTag1 = "beamng";
   materialTag0 = "beamng";
   materialTag2 = "Industrial";
};

singleton Material(TITAN_annihilator_interior)
{
   mapTo = "annihilator_interior";
   diffuseColor[0] = "0.8 0.8 0.8 1";
   specular[0] = "0.5 0.5 0.5 1";
   specularPower[0] = "50";
   translucentBlendOp = "None";
   diffuseMap[0] = "vehicles/TITAN/annihilator_interior.png";
   diffuseMap[1] = "vehicles/TITAN/annihilator_interior.png";
   diffuseMap[2] = "vehicles/TITAN/annihilator_interior.png";
   materialTag1 = "beamng";
   materialTag0 = "beamng";
   materialTag2 = "Industrial";
};

singleton Material(titan_cargo)
{
   mapTo = "titan_cargo";
   diffuseColor[0] = "0.996078 0.996078 0.996078 1";
   specular[0] = "0.5 0.5 0.5 1";
   specularPower[0] = "50";
   translucentBlendOp = "None";
   diffuseMap[0] = "vehicles/TITAN/titan_cargo.png";
   diffuseMap[1] = "vehicles/TITAN/titan_cargo.png";
   diffuseMap[2] = "vehicles/TITAN/titan_cargo.png";
   materialTag1 = "beamng";
   materialTag0 = "beamng";
   materialTag2 = "Industrial";
};

singleton Material(TITAN_cargoplane_cockpit)
{
   mapTo = "cargoplane_cockpit";
   diffuseColor[0] = "0.8 0.8 0.8 1";
   specular[0] = "0.5 0.5 0.5 1";
   specularPower[0] = "50";
   translucentBlendOp = "None";
   diffuseMap[0] = "vehicles/TITAN/cargoplane_cockpit.png";
   diffuseMap[1] = "vehicles/TITAN/cargoplane_cockpit.png";
   diffuseMap[2] = "vehicles/TITAN/cargoplane_cockpit.png";
   materialTag1 = "beamng";
   materialTag0 = "beamng";
   materialTag2 = "Industrial";
};

singleton Material(titan_cargo_seat_net)
{
   mapTo = "titan_cargo_seat_net";
   diffuseColor[0] = "0.8 0.8 0.8 1";
   specular[0] = "0.5 0.5 0.5 1";
   specularPower[0] = "50";
   translucentBlendOp = "LerpAlpha";
   diffuseMap[0] = "vehicles/TITAN/titan_cargo_seat_net.png";
   diffuseMap[1] = "vehicles/TITAN/titan_cargo_seat_net.png";
   diffuseMap[2] = "vehicles/TITAN/titan_cargo_seat_net.png";
   translucent = "1";
   translucentZWrite = "1";
   materialTag1 = "beamng";
   materialTag0 = "beamng";
   materialTag2 = "Industrial";
};

singleton Material(TITAN_vehicle_generic_worn_diff)
{
   mapTo = "vehicle_generic_worn_diff";
   diffuseColor[0] = "0.992157 0.996078 0.992157 1";
   specular[0] = "0.5 0.5 0.5 1";
   specularPower[0] = "50";
   translucentBlendOp = "None";
   diffuseMap[0] = "vehicles/TITAN/titan_b2.png";
   diffuseMap[1] = "vehicles/TITAN/desert_camo_256.png";
   normalMap[1] = "vehicles/TITAN/112.png";
   materialTag2 = "Industrial";
   materialTag1 = "beamng";
   materialTag0 = "beamng";
   diffuseColor[2] = "1 1 1 0.73";
   diffuseMap[2] = "vehicles/TITAN/titan_b2.png";
   specularMap[2] = "vehicles/TITAN/lega_s.dds";
   cubemap = "BNG_Sky_02_cubemap";
   diffuseColor[1] = "0.964706 0.956863 0.721569 0.631";
   alphaRef = "0";
   normalMap[0] = "vehicles/TITAN/112.png";
   normalMap[2] = "vehicles/TITAN/112.png";
};

singleton Material(vehicle_generic_glasswindows2_dmg)
{
   mapTo = "vehicle_generic_glasswindows2_dmg";
   materialTag1 = "beamng";
   materialTag0 = "beamng";
   materialTag2 = "Industrial";
   diffuseMap[0] = "vehicles/TITAN/vehicle_generic_glasswindows2_DMG.png";
   diffuseMap[1] = "vehicles/TITAN/vehicle_generic_glasswindows2_DMG.png";
   diffuseMap[2] = "vehicles/TITAN/vehicle_generic_glasswindows2_DMG.png";
   translucent = "1";
};

singleton Material(vehicle_generic_glasswindows2)
{
   mapTo = "vehicle_generic_glasswindows2";
   diffuseMap[0] = "vehicles/TITAN/tex2.png";
   diffuseMap[1] = "vehicles/TITAN/tex2.png";
   diffuseMap[2] = "vehicles/TITAN/tex2.png";
   translucent = "1";
   materialTag0 = "beamng";
   materialTag1 = "beamng";
   materialTag2 = "Industrial";
};

singleton Material(vehicle_generic_tyrewallblack)
{
   mapTo = "vehicle_generic_tyrewallblack";
   materialTag0 = "beamng";
   materialTag1 = "beamng";
   materialTag2 = "Industrial";
   diffuseMap[0] = "vehicles/TITAN/tex3.png";
   diffuseMap[1] = "vehicles/TITAN/tex3.png";
   diffuseMap[2] = "vehicles/TITAN/tex3.png";
   normalMap[0] = "vehicles/TITAN/tex3_n.png";
   normalMap[1] = "vehicles/TITAN/tex3_n.png";
   normalMap[2] = "vehicles/TITAN/tex3_n.png";
};

singleton Material(vehicle_generic_detail)
{
   mapTo = "vehicle_generic_detail";
   diffuseMap[0] = "vehicles/TITAN/tex4.png";
   diffuseMap[1] = "vehicles/TITAN/tex4.png";
   diffuseMap[2] = "vehicles/TITAN/tex4.png";
   materialTag0 = "beamng";
   materialTag1 = "beamng";
   materialTag2 = "Industrial";
};

singleton Material(vehicle_generic_detail2)
{
   mapTo = "vehicle_generic_detail2";
   materialTag0 = "beamng";
   materialTag1 = "beamng";
   materialTag2 = "Industrial";
   diffuseColor[0] = "1 1 1 0.573";
   diffuseColor[1] = "1 1 1 0.523";
   diffuseColor[2] = "1 1 1 0.718";
   diffuseMap[0] = "vehicles/TITAN/tex4.png";
   diffuseMap[1] = "vehicles/TITAN/tex4.png";
   diffuseMap[2] = "vehicles/TITAN/tex4.png";
   cubemap = "BNG_Sky_02_cubemap";
};